/**
 *  Este programa é software livre; você pode redistribuí-lo e/ou
 *  modificá-lo sob os termos da Licença Pública Geral GNU, conforme
 *  publicada pela Free Software Foundation; tanto a versão 2 da
 *  Licença como (a seu critério) qualquer versão mais nova.
 *
 *  Este programa é distribuído na expectativa de ser útil, mas SEM
 *  QUALQUER GARANTIA; sem mesmo a garantia implícita de
 *  COMERCIALIZAÇÃO ou de ADEQUAÇÃO A QUALQUER PROPÓSITO EM
 *  PARTICULAR. Consulte a Licença Pública Geral GNU para obter mais
 *  detalhes.
 *
 *  Você deve ter recebido uma cópia da Licença Pública Geral GNU
 *  junto com este programa; se não, escreva para a Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 *  02111-1307, USA.
 * 
 *  Prof. Emerson Ribeiro de Mello (2011)
 *  mello@ifsc.edu.br
 */
package jogo;

import java.awt.Graphics2D;
import java.awt.Image;
import java.util.ArrayList;
import javax.swing.JLabel;

/**
 *
 * @author Emerson Ribeiro de Mello
 */
public class Jogador extends Elemento {

    protected int cima; // código da tecla para mover para cima
    protected int baixo;// código da tecla para mover para baixo
    protected int direita;// código da tecla para mover para direita
    protected int esquerda;// código da tecla para mover para esquerda
    protected int atirar;// código da tecla para atirar
    // as 2 linhas abaixo são usadas so' para depuracao
    private JLabel coordX; // JLabel no Frame principal para representar a coordenada X
    private JLabel coordY;// JLabel no Frame principal para representar a coordenada Y
    /* poderia melhorar isso aqui */
    private Image bomba; // imagem da bomba
    private Image explosao; // imagem da explosao
    private boolean bombaViva; // indica se a bomba ainda nao explodiu
    private int tempoDeVidaDaBomba; // indica o tempo que bomba vai demorar para explodir
    private boolean explodindo; // indica que a bomba esta' explodindo
    private int tempoDeExplosao; // indica o tempo que ira' demorar a explosao
    private int bX; // coordenada X da bomba
    private int bY; // coordenada Y da bomba
    private int nbomba;
    private int nubomba;
    public int nuvida;
    private bomba bombalist;
    private int ind_bom;
    private JogoTimer c;
    protected ArrayList<bomba> arraybomba = new ArrayList<bomba>();
    private boolean vivendo;
    private int tempoVivendo;
    /* poderia melhorar isso aqui */

    /**
     * 
     * @param pai referencia a area de Desenho
     * @param imagemNome - Nome da imagem que sera' usada para representar o jogador
     * @param bombaNome  - Nome da imagem que sera' usada para representar a bomba deste jogador
     * @param mX Linha na matriz
     * @param mY Coluna na matriz
     * @param c codigo da tecla que sera' usado para mover para cima
     * @param b codigo da tecla que sera' usado para mover para baixo
     * @param d codigo da tecla que sera' usado para mover para esquerda
     * @param e codigo da tecla que sera' usado para mover para direita
     * @param a codigo da tecla que sera' usado para atirar
     */
    public Jogador(JogoTimer pai, String imagemNome, String bombaNome,
            int mx, int my, int c, int b, int d, int e, int a, JLabel jLx, JLabel jLy) {
        super(pai, imagemNome, mx, my);
        this.icone = this.carregarImagem(this.imagemNome);
        this.cima = c;
        this.baixo = b;
        this.direita = d;
        this.esquerda = e;
        this.atirar = a;
        this.coordX = jLx;
        this.coordY = jLy;
        this.c = pai;
        /********** Isso poderia ser melhorado ***********/
        this.bomba = this.carregarImagem(bombaNome);
        this.explosao = this.carregarImagem("explosao.png");
        this.bombaViva = false;
        this.tempoDeVidaDaBomba = 0;
        this.explodindo = false;
        this.tempoDeExplosao = 0;
        this.nbomba = 1;
        this.ind_bom = 0;
        this.nubomba = 1;
        this.nuvida = 1;
        this.vivendo = false;
        /*************************************************/
    }

    /**
     * Desenha a imagem no contexto gráfico do Pai
     * @param g 
     */
    @Override
    public void desenhar(Graphics2D g) {
        for (int i = 0; i < arraybomba.size(); i++) {
            bombalist = arraybomba.get(i);
            bombalist.desenhar(g);
            arraybomba.set(i, bombalist);
        }
       
        g.drawImage(this.icone, this.posX, this.posY, this.jogo);


        this.atualizaRepresentacaoDasCoordenadasXY();
        if (vivendo) {
            tempoVivendo -= 10;
            if (tempoVivendo % 20 == 0) {
                this.icone = this.carregarImagem("");
            }
            if (tempoVivendo % 30 == 0) {
                this.icone = this.carregarImagem(this.imagemNome);
            }
            if (tempoVivendo < 10) {
                vivendo = false;
            }
        }
    }

    /**
     * Atualiza coordenadas, posicao na matriz e a bomba
     */
    @Override
    public void atualizar() {
        int destinoLin = matLinha; // linha destino apos o movimento
        int destinoCol = matColuna; // coluna destino apos o movimento
        int destinoX = posX; // coordenada X destino na area de desenho
        int destinoY = posY; // coordenada Y destino na area de desenho

        if (jogo.framePrincipal.teclado.teclaApertada(this.cima)) {
            destinoY = posY - this.velocidade;
            destinoLin--;
        } else if (jogo.framePrincipal.teclado.teclaApertada(this.baixo)) {
            destinoY = posY + this.velocidade;
            destinoLin++;
        } else if (jogo.framePrincipal.teclado.teclaApertada(this.esquerda)) {
            destinoX = posX - this.velocidade;
            destinoCol--;
        } else if (jogo.framePrincipal.teclado.teclaApertada(this.direita)) {
            destinoX = posX + this.velocidade;
            destinoCol++;
        }

        // se estiver a celula destino estiver livre, mova o personagem para la'
        if (jogo.estaLivre(destinoLin, destinoCol)) {
            matLinha = destinoLin;
            matColuna = destinoCol;
            posX = destinoX;
            posY = destinoY;
        }
        if (jogo.setbomba(destinoLin, destinoCol)) {
            matLinha = destinoLin;
            matColuna = destinoCol;
            posX = destinoX;
            posY = destinoY;
            this.jogo.cenario[posY / 40][posX / 40] = 2;
            nbomba++;

        }
        if (jogo.setnubomba(destinoLin, destinoCol)) {
            matLinha = destinoLin;
            matColuna = destinoCol;
            posX = destinoX;
            posY = destinoY;
            this.jogo.cenario[posY / 40][posX / 40] = 2;
            nubomba++;

        }

        if (jogo.setvida(destinoLin, destinoCol)) {
            matLinha = destinoLin;
            matColuna = destinoCol;
            posX = destinoX;
            posY = destinoY;
            this.jogo.cenario[posY / 40][posX / 40] = 2;
            nuvida++;

        }

     
        if (jogo.framePrincipal.teclado.teclaApertadaPrimeiraVez(this.atirar)) {
            this.bombaViva = true;
         
            this.bX = this.posX;
            this.bY = this.posY;

            if (this.ind_bom < nubomba) {
                arraybomba.add(new bomba(c, "bomba1.png", "bomba1.png", this.bX / 40, this.bY / 40, nbomba));
                ind_bom++;
            }
           
        }
        for (int i = 0; i < arraybomba.size(); i++) {
            bombalist = arraybomba.get(i);
            bombalist.atualizar();
            arraybomba.set(i, bombalist);
            if (bombalist.tempoDeExplosao == 0) {
                arraybomba.remove(i);
                ind_bom--;
            }

        }
    }
/**
     * Tempo de folga apos morrer
     */
    public void setNuvida() {
        if (vivendo == false) {
            nuvida--;
            tempoVivendo = 300;
        }
        vivendo = true;

    }

    /**
     * Atualiza os valores das coordenadas nos JLabel no Frame principal
     * Metodo usado so' para fins de depuracao
     */
    public void atualizaRepresentacaoDasCoordenadasXY() {
        this.coordX.setText("" + this.posX);
        this.coordY.setText("" + this.posY);
    }
}